/*
 *  server extension version of c-tree
 *	System Config
 *
 *	This program is the CONFIDENTIAL and PROPRIETARY property 
 *	of FairCom(R) Corporation. Any unauthorized use, reproduction or
 *	transfer of this program is strictly prohibited.
 *
 *      Copyright (c) 1987, 1989 FairCom
 *	(Subject to limited distribution and
 *	 restricted disclosure only.)
 *	*** ALL RIGHTS RESERVED ***
 *
 *	4006 West Broadway
 *	Columbia, MO 65203
 *
 *
 *	c-tree(R)	Version 4.3
 *			Release C
 *			February 7, 1989 17:30
 *
 */

#define MEM_CUSHION 2000 /* number of bytes to preserve for alloc */
			 /* after terminate/stay resident */



#define SRV_SMBNAME       "CTREE   "	/* server network name (8 chars) */
#define SRV_SMBNAME_NOPAD "CTREE"	/* same thing - no spaces */
#define SRV_MUXID 0x93		/* servers ID on dos int 2f chain */

/* int 2f function codes to communicate with local server */

#define I2Ftestres 0		/* test if server resident */
#define I2Frequest 1		/* send smb-like request to local server */
#define I2Fdiscon  2		/* send disconnect to local server */


#define VBLOCKID 5		/* block id code in smb */


/* smb (server message block) is defined as a byte array to avoid
 * having to compile with structure packing option
 */

typedef struct smb
{
  UTEXT		a[33];
} SMB;

/* offsets in SMB */

#define SMBid		0	/* b[4] smb id ("/0xffSMB")  */
#define SMBcmd		4	/* b	cmd code 0xff for us */
#define SMBeclass	5	/* b	error class */
#define SMBcmdx		6	/* b	set to 0xdd by us */
#define SMBerr		7	/* w	not used by us */
#define SMBctsig	10	/* b[8] set to "CTREE   " */
#define SMBwct		32	/* b	set to 0 */
#define SMBvwv		33	/*	no word parms */
#define SMBbct		33	/* w	byte parms len + 3 */
#define SMBblkid	35	/* b	a 5 */
#define SMBdatsz	36	/* w	size of following data */
#define SMBdata		38	/* b[]	variable len data msg */

/* end of ctsxcfg.h */
